fs = require('fs')
wait = require('deasync')
const mysql = require('mysql')
prompt = require('prompt')
prompt.message = ''
prompt.delimiter = ''
prompt.start()
exports.EOL = "\r\n"
exports.query = (querysting) => {
  let sync=false, error, result
  exports.sql.query( querysting,
                       (err, rows) => {
                         err ? console.log(err) : 1
                         error = err
                         result = rows
                         sync=true
                       }
                   )
  while (!sync) wait.sleep(200)
  return error ? error : result.map( v => {
    let answ = {}
    answ = v
    return v
  } )
}

exports.initsql = (db=null, objectarray = false, tblname=null, host='localhost' , user='root', pwd='') => {
  if (!exports.sql) {
    exports.sql = mysql.createConnection({
      host     : host,
      user     : user,
      password : pwd,
      database : db
    })
  }
  if (objectarray) {
    let sync=false, error, result
    //console.log(object[0])
    rows = Object.entries(objectarray[0]).map((v,k) => {
      let type = ' '
      if (Number.isInteger(v[1])) type+='int(11), '
      else if ( typeof v[1] === 'number') type+='double, '
      else type+='varchar(255),'
      return v[0] + type
    }).join('\r\n')
    let querysting = `
      CREATE TABLE ${tblname} (
      __id int(11) NOT NULL AUTO_INCREMENT,
      ${rows}
      PRIMARY KEY (__id)
      ) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci;
    `
    exports.sql.query( `DROP TABLE IF EXISTS ${tblname};`,
                         (err, rows) => {
                           err ? console.log(err) : 1
                           error = err
                           result = rows
                           sync=true
                         }
                     )
    while (!sync) wait.sleep(50)
    sync=false
    exports.sql.query( querysting,
                         (err, rows) => {
                           err ? console.log(err) : 1
                           error = err
                           result = rows
                           sync=true
                         }
                     )
    while (!sync) wait.sleep(50)
    let bc=objectarray.length
    objectarray.forEach( v => {
      x = Object.entries(v).map( z => {
        return z[0]
      }).join(',')
      y = Object.entries(v).map( z => {
        return `'${z[1]}'`
      }).join(',')
      let q = `INSERT INTO ${tblname} (${x}) values (${y})`
      exports.sql.query( q,
                           (err, rows) => {
                             err ? console.log(err) : 1
                             error = err
                             result = rows
                             bc--
                           }
                       )
    })
    while (bc) wait.sleep(50)
    return error ? error : result
  }
}

exports.Array = class extends Array {
  toMap(id) {
     return new exports.Map(this,id)
  }
}

exports.Map = class extends Map {
  constructor( t, kid ) {
    super()
    if (t) {
      t.forEach( (v,i) => {
        let id
        if (kid) id=v[kid]
        else id=i
        let no = {}
        Object.keys(v).forEach( z => {
          if (z!=kid) no[z]=v[z]
        })
        this.set( id, no )
      } ) 
    } 
  }
  toArray(id = 'id') {
    let arr=[]
    this.forEach( (v,k) => {
      v[id]=k
      arr.push(v)
    })
    return arr
  }
  union(m2, f) {
    let mret=new exports.Map
    m2.forEach( (v,k) => {
      mret.set(k,v)
    } )
    this.forEach( ( mo, k ) => {
      let uo = {}
      let at
      let eo 
      if (eo = m2.get( k )) {
        Object.keys(eo).forEach( i => uo[i]=eo[i]) 
        Object.keys(mo).forEach( i => {
          if (uo[i]) {
            if (typeof f === 'function') {
              uo[i] = f(uo[i],mo[i])
            } else {
              at = []
              at.push(uo[i])
              at.push(mo[i])
              uo[i]=at
            }
          } else uo[i]=mo[i]
        })
        mret.set(k,uo)
      } else {
        Object.keys(mo).forEach( i => uo[i]=mo[i])
        mret.set(k,uo)
      }
    })
    return mret
  }
}

exports.read = (fn, sep2 = ';', sl1=0, hl=false, sl0=0, sep1 = 'auto', cs='UTF-8') => {
  var s = fs.readFileSync(fn,cs)
  if (sep1==='auto') {
    if (s.includes('\r\n')) sep1 = '\r\n'
    else sep1 = '\n'
  }
  rows=s.split(sep1)
  keys=[], ot= new exports.Array()
  var inc=1
  if (!hl) rows[0].split(sep2).forEach(v=>keys.push(v.replace(/\s/g,'_')))
  else {
      keys=hl
      inc=0
  }
  sl0+=inc
  if (sl1>0) sl1 =- sl1
  if (sl1<0) q=rows.slice(sl0,sl1)
  else {
    if (sl0) q=rows.slice(sl0)
    else q=rows
  }
  q.map( row => {
    o = {}
    row.split(sep2).forEach( (v,k) => {
        o[keys[k]] = v.replace("'","´")
    } )
    ot.push(o)
  })
  return ot
}
exports.write = (fn, mit, sep1 = '\n', sep2 = ';', hl=false) => {
  s=''
  mit.forEach( v => {
      for (k in v) {
        s+=v[k]+sep2
      }
      s=s.substr(0,s.length-1)
      s+=sep1
  } )
  fs.writeFileSync(fn, s)
}
exports.find = (t,on,mit,pontos=false) => {
  try {
    if (pontos) {
      ot=t.find(a => a[on]==mit)
    } else {
      ker = new RegExp(mit.trim(),'i')
      ot=t.find(a => ker.test(a[on]))
    }
    return ot
  } catch(err) {
    if (!mit)
     throw('Error: missing third parameter!')
  }
}
exports.filter = (t,on,mit,pontos=false) => {
  if (pontos) {
    ot=t.filter(a => a[on]==mit)
  } else {
    ker = new RegExp(mit.trim(),'i')
    ot=t.filter(a => ker.test(a[on]))
  }
  return ot
}
exports.sort = (t,on) => {
  if (typeof t[0][on] == 'string')
    ot=t.sort( (a,b) => a[on].localeCompare(b[on]))
  if (typeof t[0][on] == 'number')
    ot=t.sort( (a,b) => a[on]-b[on] )
  return ot
}
exports.rsort = (t,on) => {
  if (typeof t[0][on] == 'string')
    ot=t.sort( (a,b) => b[on].localeCompare(a[on]))
  if (typeof t[0][on] == 'number')
    ot=t.sort( (a,b) => b[on]-a[on] )
  return ot
}
exports.max = (t,on) => {
  ot=t.sort( (a,b) => a[on]<b[on] ? 1 : -1 )
  return ot[0]
}
exports.min = (t,on) => {
  ot=t.sort( (a,b) => a[on]>b[on] ? 1 : -1 )
  return ot[0]
}

exports.input = (q) => {
  let v, anw = false
  prompt.get({
    name: 'p',
    description: '\x1b[33m' + q
  }, (err, res) => {
    if (err) v=null
    else v = res.p
    anw = true
  })
  while (!anw) wait.sleep(50)
  if (Number(v) || Number(v) === 0) v = Number(v)
  return v
}
exports.print = (q,...t) => {
  s=''
  if (!t) {
    console.log(q)
  } else {
    t.forEach( v => s+=v+" ")
    console.log(q+" "+s)
  }
}
exports.yellow = '\x1b[33m%s\x1b[0m'
exports.cyan = '\x1b[36m%s\x1b[0m'
exports.white = '\x1b[38m%s\x1b[0m'
exports.green = '\x1b[32m%s\x1b[0m'
exports.light = '\x1b[37m%s\x1b[0m'
exports.black = '\x1b[30m%s\x1b[0m'
exports.red = '\x1b[31m%s\x1b[0m'
exports.blue = '\x1b[34m%s\x1b[0m'